## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 6;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global short_name lsp-server

%global _description %{expand:
A python implementation of language server protocol. pylsp provides for 
auto-completion, code linting (via pycodestyle and pyflakes) and other features.

This package provides the python-language-server package maintained by 
spyder-IDE maintainers.
}

Name:           python-%{short_name}
Version:        1.4.1
Release:        %autorelease
Summary:        Python implementation of language server protocol

License:        MIT
URL:            https://github.com/python-lsp/%{name}
Source0:        %{pypi_source}

BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  pyproject-rpm-macros

%description %_description

%package -n     python3-%{short_name}
Summary:        %{summary}

Provides:       pylsp = %{version}-%{release}
Requires:       python3dist(autopep8)
Requires:       python3dist(flake8)
Requires:       python3dist(mccabe)
Requires:       python3dist(pycodestyle)
Requires:       python3dist(pydocstyle)
Requires:       python3dist(pyflakes)
Requires:       python3dist(pylint)
Requires:       python3dist(rope)
Requires:       python3dist(yapf)


%description -n python3-%{short_name} %_description


%pyproject_extras_subpkg -n python3-%{short_name} all


%prep
%autosetup -n %{name}-%{version}
# The extras tightly bound the versions of a number of dependencies.  These
# appear to be “preemptive” SemVer version pins rather than ones reflecting
# actual incompatibilities.
#
# python-lsp-server: FTBFS in Fedora Rawhide (F38) and F37
# https://bugzilla.redhat.com/show_bug.cgi?id=2148622
sed -r -i 's/(\b(flake8|mccabe|pycodestyle|pyflakes)\b[^,]+),.*/\1/' setup.cfg

%generate_buildrequires
%pyproject_buildrequires -x all,test

%build
%pyproject_wheel

%install
%pyproject_install

%pyproject_save_files pylsp

%check
%pytest -k "not (test_syntax_error_pyflakes or test_pylint or test_syntax_error_pylint_py3)"

%files -n python3-%{short_name} -f %{pyproject_files}
%license LICENSE
%doc README.md
%{_bindir}/pylsp

%changelog
* Tue Oct 03 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 1.4.1-6
- Add a metapackage for the “all” extra

* Thu Sep 21 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 1.4.1-5
- Loosen dependency version bounds to fix FTBFS in F37/F38
- Close RHBZ#2148622

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Mon Jul 04 2022 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.4.1-2
- Rebuild for python3.11

* Thu Mar 31 2022 Mukundan Ragavan <nonamedotc@gmail.com> - 1.4.1-1
- Update to 1.4.1

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.3.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Tue Jan 18 2022 Mukundan Ragavan <nonamedotc@fedoraproject.org> - 1.3.3-2
- Add requires on py3-docstyle

* Sat Jan 15 2022 Mukundan Ragavan <nonamedotc@fedoraproject.org> - 1.3.3-1
- Update to 1.3.3
- Add explicit requires (needed for spyder)

* Sun Sep 05 2021 Mukundan Ragavan <nonamedotc@fedoraproject.org> - 1.2.2-1
- Update to 1.2.2

* Sat Aug 14 2021 Mukundan Ragavan <nonamedotc@fedoraproject.org> - 1.2.1-1
- Update to 1.2.1

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Wed Jul 07 2021 Mukundan Ragavan <nonamedotc@fedoraproject.org> - 1.0.0-2
- Spec cleanup
- Improve description

* Mon Jul 05 2021 Mukundan Ragavan <nonamedotc@fedoraproject.org> - 1.0.0-1
- Initial package.

